﻿function sendEmail($server, $port, $enableSSL, $username, $password, $from, $to, $subject, $body) {
    $message = new-object Net.Mail.MailMessage;
    $message.From = $from
    $message.To.Add($to)
    $message.IsBodyHtml = $true

    $view = [Net.Mail.AlternateView]::CreateAlternateViewFromString($body, $null, "text/html")
    $message.AlternateViews.Add($view);
    $message.Subject = $subject

    $smtp = new-object Net.Mail.SmtpClient($server, $port);
    $smtp.EnableSSL = $enableSSL;
    if($username -ne $null -and $username -ne "" -and $password -ne $null -and $password -ne "") {
        $smtp.Credentials = New-Object System.Net.NetworkCredential($username, $password);
    }
    [Net.ServicePointManager]::SecurityProtocol = [Net.SecurityProtocolType]::Tls12
    $smtp.send($message);
}