$scriptPath = (Get-Location).Path
. $scriptPath\Common\env_conf.ps1

$conf = getConf
$sharedRowPartialUrl = '/entitybrowserweb/smartexplorer.html?sharedRow='
$librariesFolder=$conf.LibrariesFolderName

function getTableIds($transaction, $schema, $tableName, $businessKey, $value){
    $selectText = "SELECT Id FROM [$schema].[$tableName] WHERE [$businessKey] = $value"

    $SqlCmd = New-Object System.Data.SqlClient.SqlCommand
    $SqlCmd.CommandText = $selectText
    $SqlCmd.Connection = $transaction.Connection
    $SqlCmd.Transaction = $transaction  
    $reader = $SqlCmd.ExecuteReader()

    $tableIds = New-Object System.Collections.ArrayList
    while($reader.Read()){
        $addRes = $tableIds.Add($reader["Id"])
    }

    $reader.Close()
    $SqlCmd.Dispose()

    return $tableIds 
}

function GenerateRowLink($sqlConnection, $baseUrl, $applicationId, $saltKey, $schema, $tableName, $businessKey, $value) {
    $commonpath=$scriptPath+"\$librariesFolder\Baseline.Common.Management.dll"
    Add-Type -Path $commonpath

    $rowLink = $NULL

    # $sqlConnection.Open()
    $transaction = $sqlConnection.BeginTransaction()
    try
    {
        $tableIds = getTableIds $transaction $schema $tableName $businessKey $value
        for($i = 0; $i -lt $tableIds.Count; $i++){
            $tableId = $tableIds[$i]
            $jsonParam = "{`"applicationId`": `"$applicationId`", `"primaryKeys`": [$tableId]}"
            $encryptedData = [Baseline.Common.Management.Utils.AESUtils]::EncryptRijndael($jsonParam, $saltKey)
            $rowLink = "$baseUrl$sharedRowPartialUrl$encryptedData"
        }
    }
    catch [Exception]
    {
        ECHO $_.Exception.Message
    }
    finally
    {
        $transaction.Rollback()
        # $sqlConnection.Close()
        # $sqlConnection.Dispose()
    }

    return $rowLink
}
function GenerateAppLink( $baseUrl, $applicationId, $saltKey,  $businessKey, $value) {
    $commonpath=$scriptPath+"\$librariesFolder\Baseline.Common.Management.dll"
    Add-Type -Path $commonpath
    $rowLink = $NULL
    try
    {
       $jsonParam = "{`"applicationId`": `"$applicationId`", `"businessKey`": `"$businessKey`", `"value`": `"$value`"}"
       $encryptedData = [Baseline.Common.Management.Utils.AESUtils]::EncryptRijndael($jsonParam, $saltKey)
       $rowLink = "$baseUrl$sharedRowPartialUrl$encryptedData"
        
    }
    catch [Exception]
    {
        ECHO $_.Exception.Message
    }
    return $rowLink
}